﻿using System;

namespace ProgramowanieObiektowe2
{
    class Klasa : PrzestrzeńNazw.ITypZWłasnością
    {
        private int pole; //zmienna w obrębie klasy

        public int Własność
        {
            get
            {
                //kod wykonywany w momencie odczytu
                return pole;
            }
            set
            {
                //kod wykonywany w momencie zapisu
                pole = value;
            }
        }

        static Klasa()
        {
            //zainicjować elementy statyczne klasy
            int i = 1;
        }

        public Klasa() //normalny konstruktor
        {
            pole = default(int); //0

            //dowolny kod
        }

        private string pobierzŁańcuchPola() //metoda pomocnicza
        {
            return pole.ToString();
        }

        public void WyświetlaPole()
        {
            Console.WriteLine("Pole: " + pobierzŁańcuchPola());
        }

        public static string MetodaStatyczna()
        {
            return "Metoda statyczna";
        }

        public class KlasaZagnieżdżona //nested
        {

        }
    }

    static class PomocnikKlasy //helper
    {
        //rozszerzenie, extension method
        public static double ToDouble(this Klasa obiekt, int dodatkowyParametr)
        {
            return (double)obiekt.Własność;
        }
    }

    namespace PrzestrzeńNazw
    {
        struct Struktura : ITypZWłasnością
        {
            private int pole;

            public int Własność
            {
                get
                {
                    return pole;
                }
                set
                {
                    pole = value;
                }
            }
        }

        public interface ITypZWłasnością
        {
            int Własność { get; }
        }
    }

    class Program
    {
        static void Main(string[] args)
        {
            /*
            Klasa obiekt = new Klasa();
            obiekt.Własność = 1;
            Console.WriteLine(obiekt.Własność.ToString());
            obiekt.WyświetlaPole();
            Console.WriteLine(Klasa.MetodaStatyczna());
            Klasa.KlasaZagnieżdżona instancjaKlasyZagnieżdżonej = new Klasa.KlasaZagnieżdżona();
            //double wynik = PomocnikKlasy.ToDouble(obiekt, 1);
            double wynik = obiekt.ToDouble(2);
            Console.WriteLine(wynik);
            */

            /*
            Klasa instancjaKlasy = new Klasa();
            instancjaKlasy.Własność = 1;
            Klasa instancjaKlasy2 = instancjaKlasy; //kopiowanie referencji (-> jeden obiekt, dwie referencje)
            instancjaKlasy2.Własność = 2;
            Console.WriteLine(instancjaKlasy.Własność);
            Console.WriteLine(instancjaKlasy2.Własność);

            PrzestrzeńNazw.Struktura instancjaStruktury = new PrzestrzeńNazw.Struktura();
            instancjaStruktury.Własność = 1;
            PrzestrzeńNazw.Struktura instancjaStruktury2 = instancjaStruktury; //klonowanie (-> dwa obiekty)
            instancjaStruktury2.Własność = 2;
            Console.WriteLine(instancjaStruktury.Własność);
            Console.WriteLine(instancjaStruktury2.Własność);

            PrzestrzeńNazw.ITypZWłasnością kolejnaInstancja = new PrzestrzeńNazw.Struktura();
            Console.WriteLine(kolejnaInstancja.Własność);
            */

            Ułamek zero = new Ułamek();
            Ułamek pół = new Ułamek(1, 2);
            Ułamek dwa = new Ułamek(2);

            //Console.WriteLine(zero);
            //Console.WriteLine(pół);
            //Console.WriteLine(dwa);

            Ułamek brzydki = new Ułamek(16, -12);
            Console.WriteLine(brzydki);
            brzydki.Uprość();
            Console.WriteLine(brzydki);
        }
    }
}

