﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProgramowanieObiektowe2
{
    public class Ułamek //: object
    {
        public int Licznik;
        private int mianownik;

        public int Mianownik
        {
            get
            {
                return mianownik;
            }
            set
            {
                if (value == 0) throw new Exception("Mianownik nie może być równy zero");
                mianownik = value;
            }
        }

        public Ułamek(int licznik = 0, int mianownik = 1)
        {
            this.Licznik = licznik;
            this.Mianownik = mianownik;
        }

        public override string ToString()
        {
            return Licznik.ToString() + " / " + Mianownik.ToString();
        }

        public static uint ObliczNWD(uint a, uint b)
        {            
            do
            {
                if (a > b) a = a - b;
                else b = b - a;
            }
            while (a != b);
            return a;
        }

        public void Uprość()
        {
            int nwd = (int)ObliczNWD((uint)Math.Abs(Licznik), (uint)Math.Abs(Mianownik)); //obcinam wartość
            int znak = Math.Sign(Licznik * Mianownik);
            Licznik = znak * Math.Abs(Licznik) / nwd;
            Mianownik = Math.Abs(Mianownik) / nwd;
        }
    }
}
